#!/usr/bin/python

'''
sagator.py
(c) 2003-2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

__pychecker__ = 'unusednames=_ \
                 blacklist=StringIO \
                 maxreturns=20 maxlines=300 \
                 no-local no-argsused no-stringiter no-abstract no-isliteral \
                 no-stdlib no-callinit'

from aglib import *
import signal,time,avlib

# load config
try:
  from config import *
except ImportError,import_es:
  if str(import_es)[-6:]=="config":
    print "ERROR! Config file not found! Exiting now."
    sys.exit(1)
  else:
    raise

if __name__ == '__main__':
  debug.set_level(DEBUG_LEVEL)
  try:
    opts,files=getopt.gnu_getopt(sys.argv[1:],'n',
      ['help','config=','daemon','nodaemon','logfile=','debug=','test','wait'])
  except getopt.GetoptError,(msg,opt):
    print "Error:",msg
    sys.exit(1)
  if files:
    print "Unknown parameter(s):", ' '.join(files)
    sys.exit(1)
  for key,value in opts:
    if key=='--help':
      print "SAGATOR",SG_VER_REL
      print "(c) Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>"
      print "Licensed under GNU GPL."
      print ""
      print "Params: --help        this help"
      print "        --config=f    load \"f\" as alternate config (without .py extension)"
      print "        --nodaemon    don't daemonize after startup"
      print "        --logfile=l   filename for logging ('-' for stdout)"
      print "        --debug=l     set debug level to l"
      print "        --test        test configuration and exit"
      print "        --wait        wait for pid file removarion"
      sys.exit(0)
    elif key=='--config':
      try:
        exec("from %s import *" % value)
      except ImportError,import_es:
        print "ImportError:",import_es
    elif key=='--daemon':
      globals.daemon=True
    elif key in ('--nodaemon','-n'):
      globals.daemon=False
    elif key=='--logfile':
      LOGFILE=value
    elif key=='--debug':
      debug.set_level(int(value))
    elif key=='--test':
      sys.exit(0)
    elif key=='--wait':
      for t in range(50):
        time.sleep(0.1)
        if not os.path.isfile(PID_FILE):
          sys.exit(0)
      print "PID file has been not removed! SAGATOR is still running?"
      sys.exit(1)
  debug.set_logfile(LOGFILE)
  debug.chroot=CHROOT
  if USER:
    globals.USER=USER
    try:
      globals.UID=pwd.getpwnam(USER)[2]
    except KeyError,err_str:
      debug.echo(0,"ERROR, getpwnam: ",[[globals.USER]],err_str)
      sys.exit(100)
  if GROUP:
    globals.GROUP=GROUP
    try:
      globals.GID=grp.getgrnam(globals.GROUP)[2]
    except KeyError,err_str:
      debug.echo(0,"ERROR, getgrnam: ",[[globals.GROUP]],err_str)
      sys.exit(100)
  globals.CHROOT=CHROOT
  globals.SRV=SRV
  globals.pid_file=PID_FILE
  avlib.smtp.SMTP_SERVER=SMTP_SERVER
  signal.signal(signal.SIGUSR2,sigusr2)
  try:
    # start services
    if globals.daemon:
      # fork
      pid=os.fork()
      if pid>0:
        sys.exit(0)
      # redirect stdin, stout and strerr
      os.close(0) # close stdin
      os.open('/dev/null',os.O_RDONLY)
      debug.dup()
    debug.echo(1,"SAGATOR %s starting at %s" \
      % (SG_VER_REL,time.strftime("%c",time.localtime())))
    for service in SRV:
      pids=service.start()
    signal.signal(signal.SIGHUP,sighup)
    signal.signal(signal.SIGTERM,sigterm)
    signal.signal(signal.SIGCHLD,sigchld)
    if globals.daemon:
      # open PID file
      try:
        globals.pidf=open(globals.pid_file,'w')
        globals.pidf.write(str(os.getpid()))
        globals.pidf.close()
      except:
        if globals.pid_file:
          debug.echo(0,"Can't open pid file: ",globals.pid_file)
    service_pids=[service.childs for service in SRV]
    debug.echo(6,"Services finished, pids: %s" % service_pids)
    fork_time=time.time()
    while True:
      time.sleep(60)
      for service in SRV:
        if len(service.childs)<service.MIN_CHILDS:
          delta=fork_time+30-time.time()
          if delta>0:
            debug.echo(1,"%s: WARNING: Respawning too fast! Wait at least %d seconds more!" \
                       % (service.name,delta))
          else:
            # start another child
            debug.echo(1,"%s: Starting a new child ... [%s]" \
                       % (service.name,service.fork()))
            fork_time=time.time()
  except KeyboardInterrupt:
    for service in SRV:
      service.stop()
    sigterm('KeyboardInterrupt') # kill self
