'''
collector.py - statistics collector service for sagator

(c) 2003-2004 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from aglib import *
from stats import *

__all__=['collector']

class collector(service):
  '''
  Statistics collector service.
  
  This service can be used to collect some data for statistics.
  
  Usage: collector(ip_or_hostname,port,statfile='/tmp/status')
  
  Where: ip_or_hostname is an string, which defines IP to bind to
         port is an integer, which defines port number to bind to
         status_file is an string, which defines where to store status
  
  Example: collector('0.0.0.0',28)
  '''
  name='collector()'
  def __init__(self,host,port,statfile='/tmp/status'):
      self.BINDTO=(host,port)
      self.STATFILE=statfile
      self.MIN_CHILDS=0
  def start(self):
      globals.stat_coll=stats.collector(self.BINDTO,self.STATFILE)
      pid=globals.stat_coll.start()
      if pid>0:
        self.childs=[pid]
        return [pid]
      else:
        return []
